<template>
  <div
    class="breakpoint-helper"
    :style="{
      color: styleConfig.textColor,
      backgroundColor: styleConfig.backgroundColor,
      width: styleConfig.width,
      height: styleConfig.height,
    }"
  >
    <span class="screen-size-name">{{ currentScreen }}</span>
    <span class="screen-size">w: {{ currentWidth }}</span>
    <span class="screen-size">h: {{ currentHeight }}</span>
  </div>
</template>

<script>
export default {
  data() {
    return {
      screens: [],
      currentScreen: null,
      currentWidth: null,
      currentHeight: null,
      styleConfig: null,
    };
  },
  created() {
    // use styles from module (or default) config
    this.styleConfig = this.customConfig.styleConfig;

    // prepare screens object (from strings to numbers, add base size with zero value)
    Object.keys(this.customConfig.tailwindConfig.theme.screens).map(
      (screenName) => {
        const sizeNumber = +this.customConfig.tailwindConfig.theme.screens[
          screenName
        ].replace(/px/g, "");
        this.customConfig.tailwindConfig.theme.screens[screenName] = sizeNumber;
      }
    );
    this.screens = this.customConfig.tailwindConfig.theme.screens;
    this.screens.base = 0;
  },
  mounted() {
    window.addEventListener("resize", this.handleResize);

    // init screen size resolving
    this.resolveScreenSize(window);
  },
  destroyed() {
    this.$el.parentNode.removeChild(this.$el);
    window.removeEventListener("resize", this.handleResize);
  },
  methods: {
    handleResize(e) {
      this.resolveScreenSize(e.target);
    },
    resolveScreenSize(target) {
      const width = target.innerWidth;
      const height = target.innerHeight;
      const screenKeys = Object.keys(this.screens);
      let result = "base";
      screenKeys.forEach((screenKey) => {
        if (width >= this.screens[screenKey]) {
          const max =
            this.screens[result] > this.screens[screenKey] ? result : screenKey;
          result = max;
        }
      });

      this.currentScreen = result;
      this.currentWidth = width;
      this.currentHeight = height;
    },
  },
};
</script>
<style scoped>
.breakpoint-helper {
  display: flex;
  position: fixed;
  bottom: 0;
  left: 0;
  min-width: 5rem;
  min-height: 5rem;
  border-radius: 6px;
  font-size: 1.5rem;
  flex-direction: column;
  justify-content: center;
  align-items: center;
  z-index: 1000;
}

.screen-size {
  font-size: 1rem;
}
</style>
